com.ihr.xbrl.om.table.definition

## Class ConceptAspectRule

- java.lang.Object
- - com.ihr.xbrl.om.table.definition.ConceptAspectRule

- All Implemented Interfaces:
    ConceptAspectInterface, Aspect<javax.xml.namespace.QName>

      public class ConceptAspectRule
      extends java.lang.Object
      implements ConceptAspectInterface

  The Class ConceptAspectRule.
  Author:
    Ignacio

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static org.apache.log4j.Logger` | `log` The log.
    `static javax.xml.namespace.QName` | `resourceName` The Constant resourceName.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ConceptAspectRule(XBRLRuleNode ruleNode, net.sf.saxon.s9api.XdmNode aspectNode)` Instantiates a new concept aspect rule.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.Object` | `getAspectClashIdentity()` Returns an object that can be used to evaluate aspect clash.
    `int` | `getAspectType()` Returns a value from the CommonAspectRule class that identifies the aspect type.
    `javax.xml.namespace.QName` | `getConcept(XBRLStructuralTable xbrlTable)` Returns the calculated concept for this aspect.
    `javax.xml.namespace.QName` | `getMember(XBRLStructuralTable table, CellHeader[] header)` Convert this aspect into a proper Member
    `void` | `resetNode()` Reset node.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### log

          public static org.apache.log4j.Logger log

      The log.

    - #### resourceName

          public static final javax.xml.namespace.QName resourceName

      The Constant resourceName.

  - ### Constructor Detail

    - #### ConceptAspectRule

          public ConceptAspectRule(XBRLRuleNode ruleNode,
                           net.sf.saxon.s9api.XdmNode aspectNode)
                            throws XTValidationException

      Instantiates a new concept aspect rule.
      Parameters:
        `ruleNode` - the rule node
        `aspectNode` - the aspect node
      Throws:
        `XTValidationException` - the XT validation exception

  - ### Method Detail

    - #### getConcept

          public javax.xml.namespace.QName getConcept(XBRLStructuralTable xbrlTable)
                                               throws XTValidationException

      Description copied from interface: `ConceptAspectInterface`
      Returns the calculated concept for this aspect.
      Specified by:
        `getConcept` in interface `ConceptAspectInterface`
      Parameters:
        `xbrlTable` - the structural table
      Returns:
        a QName
      Throws:
        `XTValidationException` - the XT validation exception

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### getAspectClashIdentity

          public java.lang.Object getAspectClashIdentity()

      Description copied from interface: `Aspect`
      Returns an object that can be used to evaluate aspect clash.
      Specified by:
        `getAspectClashIdentity` in interface `Aspect<javax.xml.namespace.QName>`
      Returns:
        the aspect clash identity

    - #### getAspectType

          public int getAspectType()

      Description copied from interface: `Aspect`
      Returns a value from the CommonAspectRule class that identifies the aspect type.
      Specified by:
        `getAspectType` in interface `Aspect<javax.xml.namespace.QName>`
      Returns:
        the aspect type

    - #### getMember

          public javax.xml.namespace.QName getMember(XBRLStructuralTable table,
                                            CellHeader[] header)
                                              throws XTValidationException

      Description copied from interface: `Aspect`
      Convert this aspect into a proper Member depending on the aspect type. Member can be used later to search for facts that satisfy the set of members
      Specified by:
        `getMember` in interface `Aspect<javax.xml.namespace.QName>`
      Parameters:
        `table` - the table
        `header` - the header
      Returns:
        the member
      Throws:
        `XTValidationException` - the XT validation exception

    - #### resetNode

          public void resetNode()

      Description copied from interface: `ConceptAspectInterface`
      Reset node.
      Specified by:
        `resetNode` in interface `ConceptAspectInterface`